unit Shkala;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;

type
  TShkalaForm = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure Display7Seg(SegStr: string; x, y: integer; Scale: extended);
    procedure Decoder(st1: integer);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ShkalaForm: TShkalaForm;
  freg1:integer;
  se,Seg:string;


implementation

{$R *.dfm}




procedure TForm1.FormCreate(Sender: TObject);

begin

freg1 := 27200

end;

procedure TForm1.Timer1Timer(Sender: TObject);

begin
if s<59 then
s:=s+1
  else
    begin
      s:=0;
      if m<59 then
      m:=m+1
      else begin
          m:=0;

          if h<23 then
          h:=h+1
          else
          begin
              h:=0;
              s:=0;
              m:=0;
          end;
      end;
        end;
        if h<10 then
            label2.Caption:='0'+inttostr(h)
            else
            label2.Caption:=inttostr(h);

            h1 := StrToInt(label2.Caption[1]);
            Decoder(h1);
            se := seg;
            Display7Seg(se,20,40,6);

            h2 := StrToInt(label2.Caption[2]);
            Decoder(h2);
            se := seg + 'H';
            Display7Seg(se,70,40,6);

        if m<10 then
            label3.Caption:='0'+inttostr(m)
            else
            label3.Caption:=inttostr(m);

            m1 := StrToInt(label3.Caption[1]);
            Decoder(m1);
            se := seg;
            Display7Seg(se,130,40,6);

            m2 := StrToInt(label3.Caption[2]);
            Decoder(m2);
            se := seg + 'H';
            Display7Seg(se,180,40,6);

        if s<10 then
            label4.Caption:='0'+inttostr(s)
            else
            label4.Caption:=inttostr(s);

            s1 := StrToInt(label4.Caption[1]);
            Decoder(s1);
            se := seg;
            Display7Seg(Se,240,78,3);

            s2 := StrToInt(label4.Caption[2]);
            Decoder(s2);
            se := seg;
            Display7Seg(se,270,78,3);

end;

procedure TForm1.Display7Seg(SegStr: string; x, y: integer; Scale: extended);
const

  ColorOn: Tcolor = clRed;
  ColorOff: TColor = clBlack;
var
  Canvas1: TCanvas;
  x1, x2, y1, y2: integer;
begin
  Canvas1 := TCanvas.Create;

  //Canvas1.Brush.Color := clBlack;
  //Canvas1.Rectangle(10,30,305,125);
  //Canvas1.FillRect(Rect(10,30,305,125));
  //Canvas1.Rectangle(10,10,210,110);

  if Scale < 1 then
    scale := 1;
  Canvas1.Handle := Form1.Canvas.Handle;
  Canvas1.Pen.Width := Trunc(Scale);
  Canvas.Brush.Style := bsCross;





  {A}
  x1 := Trunc(x + 1 * scale);
  x2 := Trunc(x1 + 5 * scale);
  y1 := y;
  y2 := y;
  if StrPos(Pchar(SegStr), 'A') <> nil then
    Canvas1.Pen.Color := ColorOn
  else
    Canvas1.Pen.Color := ColorOff;
  Canvas1.MoveTo(x1, y1);
  Canvas1.LineTo(x2, y2);
  {G}
  y1 := Trunc(y + 6 * Scale);
  y2 := y1;
  if StrPos(Pchar(SegStr), 'G') <> nil then
    Canvas1.Pen.Color := ColorOn
  else
    Canvas1.Pen.Color := ColorOff;
  Canvas1.MoveTo(x1, y1);
  Canvas1.LineTo(x2, y2);
  {D}
  y1 := Trunc(y + 12 * Scale);
  y2 := y1;
  if StrPos(Pchar(SegStr), 'D') <> nil then
    Canvas1.Pen.Color := ColorOn
  else
    Canvas1.Pen.Color := ColorOff;
  Canvas1.MoveTo(x1, y1);
  Canvas1.LineTo(x2, y2);
  {H}
  x1 := Trunc(x + 8 * Scale);
  x2 := x1;
  if StrPos(Pchar(SegStr), 'H') <> nil then
    Canvas1.Pen.Color := ColorOn
  else
    Canvas1.Pen.Color := ColorOff;
  Canvas1.MoveTo(x1, y1);
  Canvas1.LineTo(x2, y2);
  {F}
  x1 := x;
  x2 := x;
  y1 := Trunc(y + 1 * scale);
  y2 := Trunc(y + 5 * scale);
  if StrPos(Pchar(SegStr), 'F') <> nil then
    Canvas1.Pen.Color := ColorOn
  else
    Canvas1.Pen.Color := ColorOff;
  Canvas1.MoveTo(x1, y1);
  Canvas1.LineTo(x2, y2);
  {E}
  y1 := Trunc(y + 7 * scale);
  y2 := Trunc(y + 11 * scale);
  if StrPos(Pchar(SegStr), 'E') <> nil then
    Canvas1.Pen.Color := ColorOn
  else
    Canvas1.Pen.Color := ColorOff;
  Canvas1.MoveTo(x1, y1);
  Canvas1.LineTo(x2, y2);
  {C}
  x1 := Trunc(x + 7 * scale);
  x2 := x1;
  if StrPos(Pchar(SegStr), 'C') <> nil then
    Canvas1.Pen.Color := ColorOn
  else
    Canvas1.Pen.Color := ColorOff;
  Canvas1.MoveTo(x1, y1);
  Canvas1.LineTo(x2, y2);
  {B}
  y1 := Trunc(y + 1 * scale);
  y2 := Trunc(y + 5 * scale);
  if StrPos(Pchar(SegStr), 'B') <> nil then
    Canvas1.Pen.Color := ColorOn
  else
    Canvas1.Pen.Color := ColorOff;
  Canvas1.MoveTo(x1, y1);
  Canvas1.LineTo(x2, y2);
  Canvas1.Free;
end;

 procedure TForm1.Decoder(st1: integer);

  begin
    case st1 of 1 : Seg := 'BC'     ;
                2 : Seg := 'ABDEG'  ;
                3 : Seg := 'ABCDG'  ;
                4 : Seg := 'BCFG'   ;
                5 : Seg := 'ACDFG'  ;
                6 : Seg := 'ACDEFG' ;
                7 : Seg := 'ABC'    ;
                8 : Seg := 'ABCDEFG';
                9 : Seg := 'ABCDFG' ;
                0 : Seg := 'ABCDEF' ;
    end;


   end;

end.